## ros-noetic-control-box-rst 0.0.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(control_box_rst)

set(MESSAGE_SUPPORT OFF CACHE BOOL "Message support (downloads and compiles Protobuf)" FORCE)
set(RPC_SUPPORT OFF CACHE BOOL "Network communication (downloads and comiles gRPC, requires MESSAGE_SUPPORT" FORCE)
set(YAML_SUPPORT OFF CACHE BOOL "Yaml support" FORCE)
set(BUILD_GUI OFF CACHE BOOL "Build gui (requires QT)" FORCE)
set(BUILD_TESTS OFF CACHE BOOL "Build unit tests" FORCE)

# Set to Release in order to speed up the program significantly
set(CMAKE_BUILD_TYPE Release) #None, Debug, Release, RelWithDebInfo, MinSizeRel

if (BUILD_TESTING)
  message(STATUS "Tests are currently deactivated.")
  #set(BUILD_TESTS ON)
endif()

if(CATKIN_ENABLE_TESTING AND NOT CATKIN_SKIP_TESTING) 
  message(STATUS "Catkin testing is currently deactivated.")
  #set(BUILD_TESTS ON)
endif() 

add_subdirectory(src)

# Install catkin package.xml
install(FILES package.xml DESTINATION share/control_box_rst)

=== src/CMakeLists.txt ===
# Package control-box-rst toplevel cmake

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(control-box-rst VERSION 0.1 LANGUAGES CXX)

option(MESSAGE_SUPPORT "Message support (downloads and compiles Protobuf)" ON)
option(RPC_SUPPORT "Network communication (downloads and comiles gRPC, requires MESSAGE_SUPPORT" ON)
option(YAML_SUPPORT "Yaml support" ON)
option(BUILD_GUI "Build gui (requires QT)" ON)
option(ONLY_GUI "If BUILD_GUI is on, build only parts required for running the gui" OFF)
option(BUILD_TESTS "Build unit tests" OFF)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Compile static libraries with Visual Studio
if(MSVC)
	include(cmake/msvc_static_runtime.cmake)
	# Add some common library paths to facilitate package finding
	list(APPEND CMAKE_PREFIX_PATH "C:/Qt/5.8/msvc2015_64/;C:/Qt/5.10.0/msvc2015_64/;D:/Qt/5.10.0/msvc2015_64/")
 	# Enable support of large object files and parallel builds
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /MP /maxcpucount")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP /maxcpucount")
elseif (APPLE)
	# Add some common library paths to facilitate package finding
	list(APPEND CMAKE_PREFIX_PATH "$ENV{HOME}/Applications/Qt/5.5/clang_64/")
endif(MSVC)

# Add further compiler specific flags
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	# using GCC
	# enforce error if return type is missing:
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=return-type")
endif()

# Include Boost as an imported target
#find_package(Boost REQUIRED)
#add_library(boost INTERFACE IMPORTED)
#set_property(TARGET boost PROPERTY
#    INTERFACE_INCLUDE_DIRECTORIES ${Boost_INCLUDE_DIR})

## External 3rd party libs that we include

# Gtest and Gmock for unit testing
add_subdirectory(extern/gtest EXCLUDE_FROM_ALL)

# Protobuf for serialization, parameters
add_subdirectory(extern/protobuf EXCLUDE_FROM_ALL)

# RPC with protobuf messages
add_subdirectory(extern/grpc EXCLUDE_FROM_ALL)

# yaml-cpp
add_subdirectory(extern/yaml-cpp EXCLUDE_FROM_ALL)

# Configure tests
if (BUILD_TESTS)
	enable_testing()
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/lcov.cmake.in
                       ${CMAKE_CURRENT_BINARY_DIR}/lcov.cmake @ONLY)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/lcov_skip_build.cmake.in
                       ${CMAKE_CURRENT_BINARY_DIR}/lcov_skip_build.cmake @ONLY)
endif (BUILD_TESTS)


# Targets
add_subdirectory(core)
add_subdirectory(communication)

if (NOT ONLY_GUI)
 add_subdirectory(systems)
 add_subdirectory(plants)
 add_subdirectory(controllers)
 add_subdirectory(observers)
 add_subdirectory(numerics)
 add_subdirectory(optimization)
 add_subdirectory(optimal_control)
 add_subdirectory(tasks)
 add_subdirectory(master)
endif (NOT ONLY_GUI)

add_subdirectory(gui)

# Install top-level cmake config
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/control_box_rstConfig.cmake DESTINATION share/control_box_rst)

# Documentation
find_package(Doxygen)
if (DOXYGEN_FOUND)
	# set input and output files
	set(DOXYGEN_IN ${CMAKE_CURRENT_SOURCE_DIR}/../docs/Doxyfile.config)
	set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/doxygen/Doxyfile)

	# request to configure the file
	configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT} @ONLY)

	# create custom target (add ALL if it should be part of make all)
	add_custom_target(doc
	    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
	    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doxygen
	    COMMENT "Generating API documentation with Doxygen"
	    VERBATIM )
else (DOXYGEN_FOUND)
	message("Doxygen need to be installed to generate the doxygen documentation")
endif (DOXYGEN_FOUND)

=== src/communication/CMakeLists.txt ===
# Library control-box-rst-communication
project(corbo-communication VERSION 0.1 LANGUAGES CXX)

if (NOT CUSTOM_CORBO_PROTO_MSG_DIR)
      set(CUSTOM_CORBO_PROTO_MSG_DIR ${PROJECT_SOURCE_DIR}/custom_proto)
endif (NOT CUSTOM_CORBO_PROTO_MSG_DIR)

# generate messages and services
if (MESSAGE_SUPPORT)
include(message_generation.cmake)
generate_corbo_proto_msgs(${PROJECT_SOURCE_DIR}/proto
         ${CMAKE_CURRENT_BINARY_DIR}/generated/corbo-communication
         protobuf_msg_autogeneration_target
         protobuf_srv_autogeneration_target
         protobuf_grpc_autogeneration_target
         ${MESSAGE_SUPPORT}
         ${CUSTOM_CORBO_PROTO_MSG_DIR}
)
endif (MESSAGE_SUPPORT)
# check variables

if (RPC_SUPPORT AND NOT MESSAGE_SUPPORT)
	message(FATAL_ERROR "RPC_SUPPORT can only activated if MESSAGE_SUPPORT is on as well")
endif (RPC_SUPPORT AND NOT MESSAGE_SUPPORT)

# Create library

if (MESSAGE_SUPPORT)
# Workaround to set the following property: include directories are not created until building
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/generated/corbo-communication)
endif (MESSAGE_SUPPORT)

add_library(corbo_communication STATIC
    src/main_service_client.cpp
    src/signal_target_rpc.cpp
    src/message_parser.cpp
    src/utilities.cpp
    ${proto_msg_gen_cpp_src}
    ${proto_srv_gen_cpp_src}
    ${proto_grpc_gen_cpp_src}
)
target_link_libraries(corbo_communication
    corbo_core
)

if (MESSAGE_SUPPORT)
    target_compile_definitions(corbo_communication PUBLIC MESSAGE_SUPPORT)
    target_link_libraries(corbo_communication libprotobuf)
    add_dependencies(corbo_communication libprotobuf protobuf_msg_autogeneration_target)
else (MESSAGE_SUPPORT)
    message(STATUS "Message support disabled, since MESSAGE_SUPPORT=False.")
endif (MESSAGE_SUPPORT)


if (RPC_SUPPORT)
   target_compile_definitions(corbo_communication PUBLIC RPC_SUPPORT)
   target_link_libraries(corbo_communication libgrpc)
   add_dependencies(corbo_communication protobuf_srv_autogeneration_target protobuf_grpc_autogeneration_target)
else (RPC_SUPPORT)
    message(STATUS "Rpc support disabled, since RPC_SUPPORT=False.")
endif (RPC_SUPPORT)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_communication PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/control_box_rst>
    PRIVATE src)

target_compile_features(corbo_communication
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates
)

# Set compiler definitions (required on windows for grpc)
if (MSVC)
    target_compile_definitions(corbo_communication PUBLIC -D_WIN32_WINNT=0x600)
endif (MSVC)


# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_communication PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/generated/corbo-communication>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/generated>
  $<INSTALL_INTERFACE:include/control_box_rst>
)


# 'make install' to the correct location
install(TARGETS corbo_communication EXPORT corbo_communicationConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst) # TODO install generated files

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_communicationConfig DESTINATION share/control_box_rst/corbo_communication)

# This makes the project importable from the build directory
export(TARGETS corbo_communication FILE corbo_communicationConfig.cmake)


# Add unit tests
if (BUILD_TESTS)
        add_executable(test_communication
            test/communication_test.cpp)

        target_link_libraries(test_communication
            corbo_communication
            gtest
            #gmock
        )
        add_test(test_communication_test test_communication)
endif (BUILD_TESTS)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_communication_headers SOURCES ${HeaderFiles})

=== src/controllers/CMakeLists.txt ===
# Library control-box-rst-controllers
project(corbo-controllers VERSION 0.1 LANGUAGES CXX)

add_library(corbo_controllers STATIC
    src/controller_interface.cpp
    src/pid_controller.cpp
    src/lqr_controller.cpp
    src/simple_state_controller.cpp
    src/predictive_controller.cpp
    src/dual_mode_controller.cpp
)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_controllers PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/control_box_rst>
    PRIVATE src)

# If we have compiler requirements for this library, list them here
target_compile_features(corbo_controllers
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates)

# Set compiler definitions
# target_compile_definitions(controllerslib PRIVATE MYDEF=${BLABLA})
# Set compiler optoins/flags
# target_compile_options(controllerslib PUBLIC -fno-elide-constructors)


# Depend on a library that we defined in the top-level file
target_link_libraries(corbo_controllers
    corbo_core
    corbo_communication
    corbo_systems
    corbo_optimal_control
    corbo_communication
)


# 'make install' to the correct location
install(TARGETS corbo_controllers EXPORT corbo_controllersConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst)

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_controllersConfig DESTINATION share/control_box_rst/corbo_controllers)

# This makes the project importable from the build directory
export(TARGETS corbo_controllers FILE corbo_controllersConfig.cmake)

# Add unit tests
if (BUILD_TESTS)
	add_executable(test_controllers
            test/test_pid_controller.cpp)

	target_link_libraries(test_controllers
	    corbo_controllers
	    gtest
	    #gmock
	)
	add_test(test_controllers_test test_controllers)
endif (BUILD_TESTS)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_controllers_headers SOURCES ${HeaderFiles})

=== src/core/CMakeLists.txt ===
# Library control-box-rst-controllers
project(corbo-core VERSION 0.1 LANGUAGES CXX)

# Include Eigen
find_package(Eigen3 QUIET)
set(EIGEN3_BUILD_INTERFACE_INCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/../extern/eigen3)
set(EIGEN3_INSTALL_INTERFACE_INCLUDE include/control_box_rst/eigen3)
if (Eigen3_FOUND)
  message(STATUS "Eigen3 found in ${EIGEN3_INCLUDE_DIR}. Using this version instead of the included one.")
  set(EIGEN3_BUILD_INTERFACE_INCLUDE ${EIGEN3_INCLUDE_DIR})
  set(EIGEN3_INSTALL_INTERFACE_INCLUDE ${EIGEN3_BUILD_INTERFACE_INCLUDE})
else (Eigen3_FOUND)
  message(STATUS "Using internal Eigen3 version.")
endif(Eigen3_FOUND)

add_library(corbo_core STATIC
    src/global.cpp
    src/time.cpp
    src/reference_trajectory.cpp
    src/time_series.cpp
    src/signals.cpp
    src/common_signal_target.cpp
    src/data_exporter_interface.cpp
    src/yaml_export.cpp
    src/tsv_export.cpp
)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_core PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${EIGEN3_BUILD_INTERFACE_INCLUDE}>
    $<INSTALL_INTERFACE:include/control_box_rst>
    $<INSTALL_INTERFACE:${EIGEN3_INSTALL_INTERFACE_INCLUDE}>
    PRIVATE src)

# If we have compiler requirements for this library, list them here
target_compile_features(corbo_core
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates)

# Set compiler definitions
# e.g., we enable _USE_MATH_DEFINES in order to include M_PI etc. also on visual stuio
target_compile_definitions(corbo_core PUBLIC -D_USE_MATH_DEFINES)
# Set compiler optoins/flags
# target_compile_options(controllerslib PUBLIC -fno-elide-constructors)


# we are currently using the cmake module path in the toplevel cmake directory
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../cmake/modules/")

find_package(MATIO)
if(MATIO_FOUND)
    message(STATUS "MatIO found.")
    target_compile_definitions(corbo_core PUBLIC -DMATIO)
    target_include_directories(corbo_core PUBLIC ${MATIO_INCLUDE_DIRS})
    target_link_libraries(corbo_core ${MATIO_LIBRARIES})
endif(MATIO_FOUND)

if (YAML_SUPPORT)
    target_compile_definitions(corbo_core PUBLIC -DYAML_SUPPORT)
    target_link_libraries(corbo_core libyamlcpp)
endif (YAML_SUPPORT)

if(MESSAGE_SUPPORT)
     target_link_libraries(corbo_core corbo_communication)
endif(MESSAGE_SUPPORT)

# 'make install' to the correct location
install(TARGETS corbo_core EXPORT corbo_coreConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst)

# install eigen if not found
if(NOT Eigen3_FOUND)
install(DIRECTORY ${EIGEN3_BUILD_INTERFACE_INCLUDE} DESTINATION include/control_box_rst/eigen3)
endif(NOT Eigen3_FOUND)

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_coreConfig DESTINATION share/control_box_rst/corbo_core)

# This makes the project importable from the build directory
export(TARGETS corbo_core FILE corbo_coreConfig.cmake)

# Add unit tests
if (BUILD_TESTS)
	add_executable(test_core
            test/test_main.cpp
            test/test_yaml_export.cpp)

	target_link_libraries(test_core
	    corbo_core
	    gtest
	    #gmock
	)
	add_test(test_core_test test_core)
endif (BUILD_TESTS)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_core_headers SOURCES ${HeaderFiles})

=== src/gui/CMakeLists.txt ===
# Library control-box-rst-gui
project(corbo-gui VERSION 0.1 LANGUAGES CXX)

## check variables

if (NOT BUILD_GUI)
   message(STATUS "Skipping corbo-gui build, since BUILD_GUI is disabled")
   return()
endif (NOT BUILD_GUI)

if (NOT RPC_SUPPORT)
   message(STATUS "Skipping corbo-gui build, since RPC_SUPPORT is disabled")
   return()
endif (NOT RPC_SUPPORT)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_gui_headers SOURCES ${HeaderFiles})

# Find the QtWidgets library
find_package(Qt5Gui REQUIRED)
find_package(Qt5Widgets REQUIRED)
# Qt5PrintSupport is required for QCustomPlot
find_package(Qt5PrintSupport REQUIRED)

# Include QCustomPlot
set(QCUSTOMPLOT_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../extern/qcustomplot" CACHE PATH "")

# Find and Configure QT
# Find includes in corresponding build directories
#set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)
# Fixme: CMake's Automoc features does not find headers automatically yet
#        if located in another location (e.g. include/..) rather than src/).
# Workaround: Parse all header files:
qt5_wrap_cpp(MOC_CPP ${HeaderFiles})

add_library(corbo_gui_lib STATIC
    src/main_window.cpp
    src/toolbox_widget.cpp
    src/signal_widget.cpp
    src/signal_collection_widget.cpp
    src/signal_helper.cpp
    src/scope_widget.cpp
    src/scope_collection_widget.cpp
    src/parameter_widget.cpp
    src/label_edit_widget.cpp
    src/label_slider_widget.cpp
    src/label_combobox_widget.cpp
    src/label_horizontal_line_widget.cpp
    src/horizontal_button_group.cpp
    src/collapsable_groupbox.cpp
    src/one_of_param_widget.cpp
    src/extended_tree_widget.cpp
    src/parameter_cache.cpp
    src/color_manager.cpp
    ${QCUSTOMPLOT_PATH}/qcustomplot.cpp
    ${MOC_CPP}
)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_gui_lib PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${QCUSTOMPLOT_PATH}>
    $<INSTALL_INTERFACE:include/control_box_rst>
    PRIVATE src)

# If we have compiler requirements for this library, list them here
target_compile_features(corbo_gui_lib
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates)


# Depend on a library that we defined in the top-level file
target_link_libraries(corbo_gui_lib
    corbo_communication
    Qt5::Gui
    Qt5::Widgets
    Qt5::PrintSupport
)

# mock only for library target before!
set(CMAKE_AUTOMOC OFF)

# Gui application
add_executable(corbo_gui
    src/app.cpp
)

target_link_libraries(corbo_gui
    corbo_gui_lib
)


# 'make install' to the correct location
install(TARGETS corbo_gui_lib corbo_gui EXPORT corbo_guiConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst)

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_guiConfig DESTINATION share/control_box_rst/corbo_gui)

# This makes the project importable from the build directory
export(TARGETS corbo_gui_lib corbo_gui FILE corbo_guiConfig.cmake)

# Add unit tests
if (BUILD_TESTS)
	add_executable(test_gui
	    test/gui_test.cpp)

	target_link_libraries(test_gui
	    corbo_gui_lib
	    gtest
	    #gmock
	)
	add_test(test_gui_test test_gui)
endif (BUILD_TESTS)


# copy dlls
set(QT5_PATH "${Qt5Core_DIR}/../../../")
#message(STATUS "QT5 Dir: ${QT5_PATH}")
if (WIN32 AND MSVC)
        file(COPY ${QT5_PATH}/bin/Qt5Core.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Release/)
        file(COPY ${QT5_PATH}/bin/Qt5Cored.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Debug/)
        file(COPY ${QT5_PATH}/bin/Qt5Gui.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Release/)
        file(COPY ${QT5_PATH}/bin/Qt5Guid.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Debug/)
        file(COPY ${QT5_PATH}/bin/Qt5Widgets.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Release/)
        file(COPY ${QT5_PATH}/bin/Qt5Widgetsd.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Debug/)
        file(COPY ${QT5_PATH}/bin/Qt5PrintSupport.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Release/)
        file(COPY ${QT5_PATH}/bin/Qt5PrintSupportd.dll DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/Debug/)
elseif (WIN32 AND MINGW)
        file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/extern/mingw-dlls/ DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
endif (WIN32 AND MSVC)

#if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
#    set_target_properties(teb_gui PROPERTIES LINK_FLAGS_DEBUG "/SUBSYSTEM:WINDOWS")
#    set_target_properties(teb_gui PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS")
#endif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

=== src/master/CMakeLists.txt ===
# Library control-box-rst-controllers
project(corbo-master VERSION 0.1 LANGUAGES CXX)

if (NOT RPC_SUPPORT)
   message(STATUS "Skipping corbo-master build, since RPC_SUPPORT is disabled")
   return()
endif (NOT RPC_SUPPORT)

add_library(corbo_master_lib STATIC
    src/master.cpp
)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_master_lib PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/control_box_rst>
    PRIVATE src)

# If we have compiler requirements for this library, list them here
target_compile_features(corbo_master_lib
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates)

# Set compiler definitions
# target_compile_definitions(controllerslib PRIVATE MYDEF=${BLABLA})

# Set compiler optoins/flags
# target_compile_options(corbo_master_lib PUBLIC /MTd)

# Depend on a library that we defined in the top-level file
target_link_libraries(corbo_master_lib
    corbo_communication
    corbo_tasks
)

# Gui application
add_executable(corbo_master
    src/app.cpp
)

target_link_libraries(corbo_master
    corbo_master_lib
)


# 'make install' to the correct location
install(TARGETS corbo_master_lib corbo_master EXPORT corbo_masterConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst)

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_masterConfig DESTINATION share/control_box_rst/corbo_master)

# This makes the project importable from the build directory
export(TARGETS corbo_master_lib corbo_master FILE corbo_masterConfig.cmake)

# Add unit tests
if (BUILD_TESTS)
	add_executable(test_master
	    test/master_test.cpp)

	target_link_libraries(test_master
	    corbo_master_lib
	    gtest
	    #gmock
	)
	add_test(test_master_test test_master)
endif (BUILD_TESTS)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_master_headers SOURCES ${HeaderFiles})

=== src/numerics/CMakeLists.txt ===
# Library control-box-rst-numerics
project(corbo-numerics VERSION 0.1 LANGUAGES CXX)

add_library(corbo_numerics STATIC
    src/algebraic_riccati_continuous.cpp
    src/algebraic_riccati_discrete.cpp
    src/controllability.cpp
    src/observability.cpp
    src/finite_differences.cpp
    src/lyapunov_continuous.cpp
    src/lyapunov_discrete.cpp
    src/sylvester_continuous.cpp
    src/sylvester_discrete.cpp
    src/schur.cpp
)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_numerics PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/control_box_rst>
    PRIVATE src)

# If we have compiler requirements for this library, list them here
target_compile_features(corbo_numerics
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates)

# Set compiler definitions
# target_compile_definitions(controllerslib PRIVATE MYDEF=${BLABLA})
# Set compiler optoins/flags
# target_compile_options(controllerslib PUBLIC -fno-elide-constructors)


# Depend on a library that we defined in the top-level file
target_link_libraries(corbo_numerics
    corbo_core
    corbo_systems
)


# 'make install' to the correct location
install(TARGETS corbo_numerics EXPORT corbo_numericsConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst)

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_numericsConfig DESTINATION share/control_box_rst/corbo_numerics)

# This makes the project importable from the build directory
export(TARGETS corbo_numerics FILE corbo_numericsConfig.cmake)

# Add unit tests
if (BUILD_TESTS)
	add_executable(test_numerics
	    test/test_main.cpp
            test/test_finite_differences.cpp
            test/test_algebraic_riccati_continuous.cpp
            test/test_algebraic_riccati_discrete.cpp
            test/test_lyapunov_continuous.cpp
            test/test_lyapunov_discrete.cpp
            test/test_sylvester_continuous.cpp
            test/test_sylvester_discrete.cpp
            test/test_observability.cpp
            test/test_controllability.cpp
            test/test_schur.cpp
            test/test_matrix_utilities.cpp
)

	target_link_libraries(test_numerics
	    corbo_numerics
	    gtest
	    #gmock
	)
        add_test(test_numerics_test test_numerics)
endif (BUILD_TESTS)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_numerics_headers SOURCES ${HeaderFiles})

=== src/observers/CMakeLists.txt ===
# Library control-box-rst-observers
project(corbo-observers VERSION 0.1 LANGUAGES CXX)

add_library(corbo_observers STATIC
    src/dummy.cpp
)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_observers PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/control_box_rst>
    PRIVATE src)

# If we have compiler requirements for this library, list them here
target_compile_features(corbo_observers
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates)

# Set compiler definitions
# target_compile_definitions(controllerslib PRIVATE MYDEF=${BLABLA})
# Set compiler optoins/flags
# target_compile_options(controllerslib PUBLIC -fno-elide-constructors)


# Depend on a library that we defined in the top-level file
target_link_libraries(corbo_observers
    corbo_core
    corbo_communication
)


# 'make install' to the correct location
install(TARGETS corbo_observers EXPORT corbo_observersConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst)

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_observersConfig DESTINATION share/control_box_rst/corbo_observers)

# This makes the project importable from the build directory
export(TARGETS corbo_observers FILE corbo_observersConfig.cmake)

# Add unit tests
if (BUILD_TESTS)
	add_executable(test_observers
	    test/observers_test.cpp)

	target_link_libraries(test_observers
	    corbo_observers
	    gtest
	    #gmock
	)
        add_test(test_observers_test test_observers)
endif (BUILD_TESTS)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_observers_headers SOURCES ${HeaderFiles})

=== src/optimal_control/CMakeLists.txt ===
# Library control-box-rst-optimal-control
project(corbo-optimal-control VERSION 0.1 LANGUAGES CXX)

add_library(corbo_optimal_control STATIC
    src/structured_ocp/structured_optimal_control_problem.cpp
    src/structured_ocp/discretization_grids/full_discretization_grid_base.cpp
    src/structured_ocp/discretization_grids/full_discretization_grid_move_blocking_base.cpp
    src/structured_ocp/discretization_grids/non_uniform_full_discretization_grid_base.cpp
    src/structured_ocp/discretization_grids/shooting_grid_base.cpp
    src/structured_ocp/discretization_grids/non_uniform_shooting_grid_base.cpp
    src/structured_ocp/discretization_grids/finite_differences_grid.cpp
    src/structured_ocp/discretization_grids/finite_differences_grid_move_blocking.cpp
    src/structured_ocp/discretization_grids/finite_differences_variable_grid.cpp
    src/structured_ocp/discretization_grids/non_uniform_finite_differences_variable_grid.cpp
    src/structured_ocp/discretization_grids/multiple_shooting_grid.cpp
    src/structured_ocp/discretization_grids/multiple_shooting_variable_grid.cpp
    src/structured_ocp/discretization_grids/non_uniform_multiple_shooting_variable_grid.cpp
    src/functions/stage_functions.cpp
    src/functions/stage_preprocessor.cpp
    src/functions/nlp_functions.cpp
    src/functions/quadratic_cost.cpp
    src/functions/quadratic_state_cost.cpp
    src/functions/quadratic_control_cost.cpp
    src/functions/final_state_cost.cpp
    src/functions/final_state_constraints.cpp
)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_optimal_control PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/control_box_rst>
    PRIVATE src)

# If we have compiler requirements for this library, list them here
target_compile_features(corbo_optimal_control
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates)

# Set compiler definitions
# target_compile_definitions(controllerslib PRIVATE MYDEF=${BLABLA})
# Set compiler optoins/flags
# target_compile_options(controllerslib PUBLIC -fno-elide-constructors)

# we are currently using the cmake module path in the toplevel cmake directory
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../cmake/modules/")


# Depend on a library that we defined in the top-level file
target_link_libraries(corbo_optimal_control
    corbo_core
    corbo_communication
    corbo_optimization
    corbo_numerics
    corbo_systems
)


# 'make install' to the correct location
install(TARGETS corbo_optimal_control EXPORT corbo_optimal_controlConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst)

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_optimal_controlConfig DESTINATION share/control_box_rst/corbo_optimal_control)

# This makes the project importable from the build directory
export(TARGETS corbo_optimal_control FILE corbo_optimal_controlConfig.cmake)

# Add unit tests
if (BUILD_TESTS)
	add_executable(test_optimal_control
	    test/test_main.cpp
            #test/test_full_discretization_grid.cpp
            #test/test_multiple_shooting_grid.cpp
            #test/test_single_shooting_grid.cpp
	)

	target_link_libraries(test_optimal_control
            corbo_optimal_control
	    gtest
	    #gmock
	)
        add_test(test_optimal_control_test test_optimal_control)
endif (BUILD_TESTS)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_optimal_control_headers SOURCES ${HeaderFiles})

=== src/optimization/CMakeLists.txt ===
# Library control-box-rst-optimization
project(corbo-optimization VERSION 0.1 LANGUAGES CXX)

add_library(corbo_optimization STATIC
    src/optimization_problem_interface.cpp
    src/simple_optimization_problem.cpp
    src/hyper_graph/hyper_graph_optimization_problem_base.cpp
    src/hyper_graph/hyper_graph_optimization_problem_edge_based.cpp
    src/hyper_graph/hyper_graph_optimization_problem_vertex_based.cpp
    src/hyper_graph/edge_interface.cpp
    src/hyper_graph/edge_set.cpp
    src/hyper_graph/vertex_set.cpp
    src/hyper_graph/vertex_interface.cpp
    src/hyper_graph/hyper_graph.cpp
    src/solver/levenberg_marquardt_dense.cpp
    src/solver/levenberg_marquardt_sparse.cpp
    src/solver/nlp_solver_ipopt.cpp
    src/solver/nlp_solver_ipopt_wrapper.cpp
    src/solver/qp_solver_osqp.cpp
    src/misc.cpp
)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_optimization PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/control_box_rst>
    PRIVATE src)

# If we have compiler requirements for this library, list them here
target_compile_features(corbo_optimization
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates)

# Set compiler definitions
# target_compile_definitions(controllerslib PRIVATE MYDEF=${BLABLA})
# Set compiler optoins/flags
# target_compile_options(controllerslib PUBLIC -fno-elide-constructors)

# we are currently using the cmake module path in the toplevel cmake directory
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../cmake/modules/")

find_package(IPOPT QUIET)
if(IPOPT_FOUND)
    message(STATUS "IPOPT found.")
    target_compile_definitions(corbo_optimization PUBLIC ${IPOPT_DEFINITIONS} -DIPOPT)
    target_include_directories(corbo_optimization PUBLIC ${IPOPT_INCLUDE_DIRS})
    SET( CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${IPOPT_LINK_FLAGS}" )
    target_link_libraries(corbo_optimization ${IPOPT_LIBRARIES})
else(IPOPT_FOUND)
    message(STATUS "IPOPT not found. Solver IPOPT will not be available.")
endif(IPOPT_FOUND)

find_package(osqp QUIET)
if(osqp_FOUND)
    message(STATUS "OSQP found.")
    target_compile_definitions(corbo_optimization PUBLIC -DOSQP)
    set (CMAKE_CXX_LINK_EXECUTABLE "${CMAKE_CXX_LINK_EXECUTABLE} -ldl")
    target_link_libraries(corbo_optimization osqp::osqpstatic -ldl)
else(osqp_FOUND)
    message(STATUS "OSQP not found. Solver OSQP will not be available.")
endif(osqp_FOUND)

# Depend on a library that we defined in the top-level file
target_link_libraries(corbo_optimization
    corbo_core
    corbo_communication
    corbo_numerics
    corbo_systems
)


# 'make install' to the correct location
install(TARGETS corbo_optimization EXPORT corbo_optimizationConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst)

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_optimizationConfig DESTINATION share/control_box_rst/corbo_optimization)

# This makes the project importable from the build directory
export(TARGETS corbo_optimization FILE corbo_optimizationConfig.cmake)

# Add unit tests
if (BUILD_TESTS)
	add_executable(test_optimization
	    test/test_main.cpp
            test/test_simple_optimization_problem.cpp
            test/test_hyper_graph_optimization_problem_ignore_structure.cpp
            test/test_hyper_graph_optimization_problem_edge_based.cpp
            test/test_hyper_graph_optimization_problem_vertex_based.cpp
            test/test_hyper_graph.cpp
            test/test_solver_ipopt.cpp
            test/test_solver_osqp.cpp
            #test/test_levenberg_marquardt_dense.cpp
            #test/test_levenberg_marquardt_dense_hyper_graph.cpp
            #test/test_levenberg_marquardt_sparse.cpp
	)

	target_link_libraries(test_optimization
            corbo_optimization
	    gtest
	    #gmock
	)
        add_test(test_optimization_test test_optimization)
endif (BUILD_TESTS)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_optimization_headers SOURCES ${HeaderFiles})

=== src/plants/CMakeLists.txt ===
# Library control-box-rst-plants
project(corbo-plants VERSION 0.1 LANGUAGES CXX)

add_library(corbo_plants STATIC
    src/plant_interface.cpp
    src/simulated_plant.cpp
    src/simulated_plant_threaded.cpp
    src/disturbances.cpp
)

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build paths.
target_include_directories(corbo_plants PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/control_box_rst>
    PRIVATE src)

# If we have compiler requirements for this library, list them here
target_compile_features(corbo_plants
    PUBLIC cxx_auto_type cxx_range_for cxx_constexpr cxx_lambdas
    PRIVATE cxx_variadic_templates)

# Set compiler definitions
# target_compile_definitions(controllerslib PRIVATE MYDEF=${BLABLA})
# Set compiler optoins/flags
# target_compile_options(controllerslib PUBLIC -fno-elide-constructors)


# Depend on a library that we defined in the top-level file
target_link_libraries(corbo_plants
    corbo_core
    corbo_communication
    corbo_systems
)


# 'make install' to the correct location
install(TARGETS corbo_plants EXPORT corbo_plantsConfig
    ARCHIVE  DESTINATION lib/control_box_rst
    LIBRARY  DESTINATION lib/control_box_rst
    RUNTIME  DESTINATION bin/control_box_rst)  # This is for Windows
install(DIRECTORY include/ DESTINATION include/control_box_rst)

# This makes the project importable from the install directory
# Put config file in per-project dir (name MUST match), can also
# just go into <prefix>/cmake.
install(EXPORT corbo_plantsConfig DESTINATION share/control_box_rst/corbo_plants)

# This makes the project importable from the build directory
export(TARGETS corbo_plants FILE corbo_plantsConfig.cmake)

# Add unit tests
if (BUILD_TESTS)
	add_executable(test_plants
	    test/system_test.cpp)

	target_link_libraries(test_plants
	    corbo_plants
	    gtest
	    #gmock
	)
	add_test(test_plants_test test_plants)
endif (BUILD_TESTS)

# Add header files as custom target in order to display them in the IDE
# TODO check for a cleaner solution
FILE(GLOB_RECURSE HeaderFiles
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(corbo_plants_headers SOURCES ${HeaderFiles})

=== debian/changelog ===
ros-noetic-control-box-rst (0.0.7-1focal) focal; urgency=high

  * Fixed issue: Wrong sparse Jacobian pattern in solver LM
  * Stage functions: added dedicated method for state and time dependency
  * Lsq form added to hybrid cost functions
  * Added missing header for eigenvalue computation
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Thu, 04 Jun 2020 22:00:00 -0000

ros-noetic-control-box-rst (0.0.6-1focal) focal; urgency=high

  * Hybrid cost functions added: Minimum time and control/state quadratic form
  * Discretization grids: The time difference is now initialized to dt_ref for proper reference caching
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Sat, 23 May 2020 22:00:00 -0000

ros-noetic-control-box-rst (0.0.5-1focal) focal; urgency=high

  * Changed minimum CMake version to 3.1
  * Add default parameter to SolverIpopt::initialize() in case Ipopt is not found..
  * Removed obsolete gmock include
  * Fix setLastControlRef and graph consistency.
  * Internal libgtest target renamed. Fixed compilation issue for yaml-cpp test
  * Contributors: Christoph Rösmann, Maximilian Krämer

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Tue, 12 May 2020 22:00:00 -0000

ros-noetic-control-box-rst (0.0.4-1focal) focal; urgency=high

  * Removed exec_depend on catkin to allow the use of the same release for ros1 and ros2
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Thu, 20 Feb 2020 23:00:00 -0000

ros-noetic-control-box-rst (0.0.3-1focal) focal; urgency=high

  * Changed build_type to cmake in package.xml according to REP-136
  * Set some optional findPackage cmake scripts to quiet
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Thu, 20 Feb 2020 23:00:00 -0000

ros-noetic-control-box-rst (0.0.2-1focal) focal; urgency=high

  * Changed ros dependency from eigen3 to eigen
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Tue, 18 Feb 2020 23:00:00 -0000

ros-noetic-control-box-rst (0.0.1-1focal) focal; urgency=high

  * First release
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Tue, 18 Feb 2020 23:00:00 -0000

=== debian/control ===
Source: ros-noetic-control-box-rst
Section: misc
Priority: optional
Maintainer: Christoph Rösmann <christoph.roesmann@tu-dortmund.de>
Build-Depends: debhelper (>= 9.0.0), cmake, coinor-libipopt-dev, libeigen3-dev
Homepage: http://wiki.ros.org/control_box_rst
Standards-Version: 3.9.2

Package: ros-noetic-control-box-rst
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, coinor-libipopt-dev, libeigen3-dev
Description: The control_box_rst package provides C++ libraries for predictive control, direct optimal control, optimization and simulation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-control-box-rst//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
